class VersionInfo:
    def __init__(self, version, date):
        self.version = version
        self.date = date


class Book:
    def __init__(self, title, author, versionInfo):
        self.title = title
        self.author = author
        self.versionInfo = versionInfo
        self.bibliography = []

    def addBibliography(self, book):
        self.bibliography.append(book)


class Catalog:
    def __init__(self):
        self.books = []

    def addBook(self, book):
        self.books.append(book)

    def displayAllBooks(self):
        self.showBooks(self.books, "all")

    def searchBooksByTitle(self, searchTitle):
        foundBook = []
        for book in self.books:
            if book.title.lower() == searchTitle.lower():
                foundBook.append(book)
        return foundBook


    def addNewVersion(self, title, newVersion):
        '''
        default setting: 1) the author and bibliography have no change in different versions.
                    2) Book titles are not case sensitive.
                    3) duplicate titles of books are not considered.

        check if the book exists in catalog,
        if exists, add a new version of the book to catalog, results in 2 versions of a book (a exist one and a newly added one)
        if not, print("Failed to add new version. No book found with the given title.\n")
        '''

        #  TODO IMPLEMENT
        


    def showBooks(self, bookList, searchTitle):
        if searchTitle != "all":
            if not bookList:
                print("No books found with the given title.\n")
            else:
                print("==== Books matching the title '{}': ====".format(searchTitle))
        else:
            print("==== All books in the catalog: ====")

        for book in bookList:
            print("Title:", book.title)
            print("Author:", book.author)
            print("Version:", book.versionInfo.version)
            print("Date:", book.versionInfo.date)
            print("Bibliography:")
            for i, biblioBook in enumerate(book.bibliography, 1):
                print("- {} Title: {}".format(i, biblioBook.title))
                print("  Author:", biblioBook.author)
                print("  Version:", biblioBook.versionInfo.version)
                print("  Date:", biblioBook.versionInfo.date)
            print()


if __name__ == '__main__':
    catalog = Catalog()

    # Create books
    program_paradigms_version = VersionInfo("First Edition", "12-2010")
    program_paradigms = Book("Programming Paradigms", "Maurizio Gabbrielli", program_paradigms_version)

    programming_languages_version = VersionInfo("Fourth Edition", "06-2008")
    programming_languages = Book("Programming languages", "Sarah Guido", programming_languages_version)

    advanced_intelligent_paradigms_version = VersionInfo("Second Edition", "05-1995")
    advanced_intelligent_paradigms = Book("Advanced Intelligent Paradigms", "Simone Martini", advanced_intelligent_paradigms_version)

    # Add bibliography books
    program_paradigms.addBibliography(programming_languages)
    program_paradigms.addBibliography(advanced_intelligent_paradigms)

    # Create library catalog
    catalog.addBook(program_paradigms)

    # Display all books in the catalog
    catalog.displayAllBooks()

    # Comment the following code and run the file directly, the results may be helpful for understanding the code.
    # Add a new version to an existing book
    new_version = VersionInfo("Second Edition", "06-2013")
    catalog.addNewVersion("Programming Paradigms", new_version)

    # Search books by title
    searchTitle = "Programming Paradigms"
    foundBooks = catalog.searchBooksByTitle(searchTitle)
    catalog.showBooks(foundBooks, searchTitle)

